unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Translations, ExtCtrls, typinfo, Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    RadioGroup1: TRadioGroup;
    Timer1: TTimer;
    ToggleBox1: TToggleBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    function  TranslateUnitCaptionStrings(const ResUnitName, AFilename: string): boolean;
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

resourcestring

  rsUeberschrift = 'Ueberschrift';

implementation

{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);
begin
  //TranslateUnitCaptionStrings('Unit1','./lang/project1.en.po');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close();
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
begin

end;


procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if radiogroup1.ItemIndex = 0 then
   begin
    TranslateUnitResourceStrings('Unit1','./lang/project1.po');
    TranslateUnitCaptionStrings('Unit1','./lang/project1.po');
   end;
  if radiogroup1.ItemIndex = 1 then
   begin
    TranslateUnitResourceStrings('Unit1','./lang/project1.en.po');
    TranslateUnitCaptionStrings('Unit1','./lang/project1.en.po');
   end;
  Form1.Caption:=rsUeberschrift;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   if radiogroup1.ItemIndex = 0 then radiogroup1.ItemIndex := 1
                                else radiogroup1.ItemIndex := 0;
end;


function TForm1.TranslateUnitCaptionStrings(const ResUnitName, AFilename: string): boolean;
var
  TableID,TableCount: Integer;
  s       : String;
  t       : String;
  ap      : String;
  captext : String;
  DefValue: String;
  po      : TPOFile;
  aForm   : TForm;
  
  CurrentComponent : TComponent;
  
begin
  Result:=false;
  if (ResUnitName='') or (AFilename='') or (not FileExists(AFilename)) then
    exit;
  try
    po := nil;
    po := TPOFile.Create(AFilename);
    aForm := self;
    try
      TableCount := Pred(aForm.ComponentCount);
      for  TableID := 0 to TableCount  do
      begin
        CurrentComponent := aForm.Components[TableID];
        DefValue:= CurrentComponent.GetNamePath;
        if DefValue[1] = 'E' then ap := 'TEXT' else ap :='CAPTION';
        t := aForm.ClassName+'.'+CurrentComponent.GetNamePath+'.'+ap;
        captext  := po.Translate(t,DefValue);
        if captext <> DefValue then
        SetWideStrProp(CurrentComponent,ap, captext);
      end;
    finally
      po.Free;
    end;
    Result:=true;
  except
    on e: Exception do begin
    // Fehlermeldung
    end;
  end;
end;


initialization
  {$I unit1.lrs}

end.

